diff --git a/config/hwloc.m4 b/config/hwloc.m4
index 91b1f9b0d9..a4b98fded0 100644
--- a/config/hwloc.m4
+++ b/config/hwloc.m4
@@ -1,6 +1,6 @@
 dnl -*- Autoconf -*-
 dnl
-dnl Copyright © 2009-2015 Inria.  All rights reserved.
+dnl Copyright © 2009-2016 Inria.  All rights reserved.
 dnl Copyright © 2009-2012, 2015 Université Bordeaux
 dnl Copyright © 2004-2005 The Trustees of Indiana University and Indiana
 dnl                         University Research and Technology
@@ -365,7 +365,7 @@ EOF])
     AC_CHECK_HEADERS([dirent.h])
     AC_CHECK_HEADERS([strings.h])
     AC_CHECK_HEADERS([ctype.h])
-    
+
     AC_CHECK_FUNCS([strncasecmp], [
       _HWLOC_CHECK_DECL([strncasecmp], [
 	AC_DEFINE([HWLOC_HAVE_DECL_STRNCASECMP], [1], [Define to 1 if function `strncasecmp' is declared by system headers])
@@ -647,6 +647,9 @@ EOF])
     AC_CHECK_HEADERS([sys/utsname.h])
     AC_CHECK_FUNCS([uname])
 
+    AC_CHECK_HEADERS([valgrind/valgrind.h])
+    AC_CHECK_DECLS([RUNNING_ON_VALGRIND],,[:],[[#include <valgrind/valgrind.h>]])
+
     AC_CHECK_HEADERS([pthread_np.h])
     AC_CHECK_DECLS([pthread_setaffinity_np],,[:],[[
       #include <pthread.h>
diff --git a/hwloc/topology-x86.c b/hwloc/topology-x86.c
index 5cfd0e8ac8..5b04e36768 100644
--- a/hwloc/topology-x86.c
+++ b/hwloc/topology-x86.c
@@ -26,6 +26,9 @@
 #ifdef HAVE_DIRENT_H
 #include <dirent.h>
 #endif
+#ifdef HAVE_VALGRIND_VALGRIND_H
+#include <valgrind/valgrind.h>
+#endif
 
 struct hwloc_x86_backend_data_s {
   unsigned nbprocs;
@@ -1205,6 +1208,15 @@ hwloc_x86_discover(struct hwloc_backend *backend)
   int alreadypus = 0;
   int ret;
 
+#if HAVE_DECL_RUNNING_ON_VALGRIND
+  if (RUNNING_ON_VALGRIND && !data->src_cpuiddump_path) {
+    fprintf(stderr, "hwloc x86 backend cannot work under Valgrind, disabling.\n"
+	    "May be reenabled by dumping CPUIDs with hwloc-gather-cpuid\n"
+	    "and reloading them under Valgrind with HWLOC_CPUID_PATH.\n");
+    return 0;
+  }
+#endif
+
   if (!data->src_cpuiddump_path)
     data->nbprocs = hwloc_fallback_nbprocessors(topology);
 
